use magick_rust;
use std::str::FromStr;
use thiserror::Error;

#[derive(PartialEq,Eq,Debug,Error)]
#[error("Unknown composition operator: {0}")]
pub struct UnknownCompositeOperator(String);

#[derive(PartialEq,Eq,Debug,Copy,Clone)]
pub enum CompositeOperator {
    Undefined,
    Alpha,
    Atop,
    Blend,
    Blur,
    Bumpmap,
    ChangeMask,
    Clear,
    ColorBurn,
    ColorDodge,
    Colorize,
    CopyBlack,
    CopyBlue,
    Copy,
    CopyCyan,
    CopyGreen,
    CopyMagenta,
    CopyAlpha,
    CopyRed,
    CopyYellow,
    Darken,
    DarkenIntensity,
    Difference,
    Displace,
    Dissolve,
    Distort,
    DivideDst,
    DivideSrc,
    DstAtop,
    Dst,
    DstIn,
    DstOut,
    DstOver,
    Exclusion,
    HardLight,
    HardMix,
    Hue,
    In,
    Intensity,
    Lighten,
    LightenIntensity,
    LinearBurn,
    LinearDodge,
    LinearLight,
    Luminize,
    Mathematics,
    MinusDst,
    MinusSrc,
    Modulate,
    ModulusAdd,
    ModulusSubtract,
    Multiply,
    No,
    Out,
    Over,
    Overlay,
    PegtopLight,
    PinLight,
    Plus,
    Replace,
    Saturate,
    Screen,
    SoftLight,
    SrcAtop,
    Src,
    SrcIn,
    SrcOut,
    SrcOver,
    Threshold,
    VividLight,
    Xor,
    Stereo,
}

impl FromStr for CompositeOperator {
    type Err = UnknownCompositeOperator;
    fn from_str(input: &str) -> Result<Self, Self::Err> {
        Ok(match input {
            "undefined" => CompositeOperator::Undefined,
            "alpha" => CompositeOperator::Alpha,
            "atop" => CompositeOperator::Atop,
            "blend" => CompositeOperator::Blend,
            "blur" => CompositeOperator::Blur,
            "bumpmap" => CompositeOperator::Bumpmap,
            "change_mask" => CompositeOperator::ChangeMask,
            "clear" => CompositeOperator::Clear,
            "color_burn" => CompositeOperator::ColorBurn,
            "color_dodge" => CompositeOperator::ColorDodge,
            "colorize" => CompositeOperator::Colorize,
            "copy_black" => CompositeOperator::CopyBlack,
            "copy_blue" => CompositeOperator::CopyBlue,
            "copy" => CompositeOperator::Copy,
            "copy_cyan" => CompositeOperator::CopyCyan,
            "copy_green" => CompositeOperator::CopyGreen,
            "copy_magenta" => CompositeOperator::CopyMagenta,
            "copy_alpha" => CompositeOperator::CopyAlpha,
            "copy_red" => CompositeOperator::CopyRed,
            "copy_yellow" => CompositeOperator::CopyYellow,
            "darken" => CompositeOperator::Darken,
            "darken_intensity" => CompositeOperator::DarkenIntensity,
            "difference" => CompositeOperator::Difference,
            "displace" => CompositeOperator::Displace,
            "dissolve" => CompositeOperator::Dissolve,
            "distort" => CompositeOperator::Distort,
            "divide_dst" => CompositeOperator::DivideDst,
            "divide_src" => CompositeOperator::DivideSrc,
            "dst_atop" => CompositeOperator::DstAtop,
            "dst" => CompositeOperator::Dst,
            "dst_in" => CompositeOperator::DstIn,
            "dst_out" => CompositeOperator::DstOut,
            "dst_over" => CompositeOperator::DstOver,
            "exclusion" => CompositeOperator::Exclusion,
            "hard_light" => CompositeOperator::HardLight,
            "hard_mix" => CompositeOperator::HardMix,
            "hue" => CompositeOperator::Hue,
            "in" => CompositeOperator::In,
            "intensity" => CompositeOperator::Intensity,
            "lighten" => CompositeOperator::Lighten,
            "lighten_intensity" => CompositeOperator::LightenIntensity,
            "linear_burn" => CompositeOperator::LinearBurn,
            "linear_dodge" => CompositeOperator::LinearDodge,
            "linear_light" => CompositeOperator::LinearLight,
            "luminize" => CompositeOperator::Luminize,
            "mathematics" => CompositeOperator::Mathematics,
            "minus_dst" => CompositeOperator::MinusDst,
            "minus_src" => CompositeOperator::MinusSrc,
            "modulate" => CompositeOperator::Modulate,
            "modulus_add" => CompositeOperator::ModulusAdd,
            "modulus_subtract" => CompositeOperator::ModulusSubtract,
            "multiply" => CompositeOperator::Multiply,
            "no" => CompositeOperator::No,
            "out" => CompositeOperator::Out,
            "over" => CompositeOperator::Over,
            "overlay" => CompositeOperator::Overlay,
            "pegtop_light" => CompositeOperator::PegtopLight,
            "pin_light" => CompositeOperator::PinLight,
            "plus" => CompositeOperator::Plus,
            "replace" => CompositeOperator::Replace,
            "saturate" => CompositeOperator::Saturate,
            "screen" => CompositeOperator::Screen,
            "soft_light" => CompositeOperator::SoftLight,
            "src_atop" => CompositeOperator::SrcAtop,
            "src" => CompositeOperator::Src,
            "src_in" => CompositeOperator::SrcIn,
            "src_out" => CompositeOperator::SrcOut,
            "src_over" => CompositeOperator::SrcOver,
            "threshold" => CompositeOperator::Threshold,
            "vivid_light" => CompositeOperator::VividLight,
            "xor" => CompositeOperator::Xor,
            "stereo" => CompositeOperator::Stereo,
            _ => return Err(UnknownCompositeOperator(input.to_owned()))
        })
    }
}

impl From<CompositeOperator> for magick_rust::bindings::CompositeOperator {
    fn from(from: CompositeOperator) -> magick_rust::bindings::CompositeOperator {
        match from {
            CompositeOperator::Undefined        => magick_rust::bindings::CompositeOperator_UndefinedCompositeOp,
            CompositeOperator::Alpha            => magick_rust::bindings::CompositeOperator_AlphaCompositeOp,
            CompositeOperator::Atop             => magick_rust::bindings::CompositeOperator_AtopCompositeOp,
            CompositeOperator::Blend            => magick_rust::bindings::CompositeOperator_BlendCompositeOp,
            CompositeOperator::Blur             => magick_rust::bindings::CompositeOperator_BlurCompositeOp,
            CompositeOperator::Bumpmap          => magick_rust::bindings::CompositeOperator_BumpmapCompositeOp,
            CompositeOperator::ChangeMask       => magick_rust::bindings::CompositeOperator_ChangeMaskCompositeOp,
            CompositeOperator::Clear            => magick_rust::bindings::CompositeOperator_ClearCompositeOp,
            CompositeOperator::ColorBurn        => magick_rust::bindings::CompositeOperator_ColorBurnCompositeOp,
            CompositeOperator::ColorDodge       => magick_rust::bindings::CompositeOperator_ColorDodgeCompositeOp,
            CompositeOperator::Colorize         => magick_rust::bindings::CompositeOperator_ColorizeCompositeOp,
            CompositeOperator::CopyBlack        => magick_rust::bindings::CompositeOperator_CopyBlackCompositeOp,
            CompositeOperator::CopyBlue         => magick_rust::bindings::CompositeOperator_CopyBlueCompositeOp,
            CompositeOperator::Copy             => magick_rust::bindings::CompositeOperator_CopyCompositeOp,
            CompositeOperator::CopyCyan         => magick_rust::bindings::CompositeOperator_CopyCyanCompositeOp,
            CompositeOperator::CopyGreen        => magick_rust::bindings::CompositeOperator_CopyGreenCompositeOp,
            CompositeOperator::CopyMagenta      => magick_rust::bindings::CompositeOperator_CopyMagentaCompositeOp,
            CompositeOperator::CopyAlpha        => magick_rust::bindings::CompositeOperator_CopyAlphaCompositeOp,
            CompositeOperator::CopyRed          => magick_rust::bindings::CompositeOperator_CopyRedCompositeOp,
            CompositeOperator::CopyYellow       => magick_rust::bindings::CompositeOperator_CopyYellowCompositeOp,
            CompositeOperator::Darken           => magick_rust::bindings::CompositeOperator_DarkenCompositeOp,
            CompositeOperator::DarkenIntensity  => magick_rust::bindings::CompositeOperator_DarkenIntensityCompositeOp,
            CompositeOperator::Difference       => magick_rust::bindings::CompositeOperator_DifferenceCompositeOp,
            CompositeOperator::Displace         => magick_rust::bindings::CompositeOperator_DisplaceCompositeOp,
            CompositeOperator::Dissolve         => magick_rust::bindings::CompositeOperator_DissolveCompositeOp,
            CompositeOperator::Distort          => magick_rust::bindings::CompositeOperator_DistortCompositeOp,
            CompositeOperator::DivideDst        => magick_rust::bindings::CompositeOperator_DivideDstCompositeOp,
            CompositeOperator::DivideSrc        => magick_rust::bindings::CompositeOperator_DivideSrcCompositeOp,
            CompositeOperator::DstAtop          => magick_rust::bindings::CompositeOperator_DstAtopCompositeOp,
            CompositeOperator::Dst              => magick_rust::bindings::CompositeOperator_DstCompositeOp,
            CompositeOperator::DstIn            => magick_rust::bindings::CompositeOperator_DstInCompositeOp,
            CompositeOperator::DstOut           => magick_rust::bindings::CompositeOperator_DstOutCompositeOp,
            CompositeOperator::DstOver          => magick_rust::bindings::CompositeOperator_DstOverCompositeOp,
            CompositeOperator::Exclusion        => magick_rust::bindings::CompositeOperator_ExclusionCompositeOp,
            CompositeOperator::HardLight        => magick_rust::bindings::CompositeOperator_HardLightCompositeOp,
            CompositeOperator::HardMix          => magick_rust::bindings::CompositeOperator_HardMixCompositeOp,
            CompositeOperator::Hue              => magick_rust::bindings::CompositeOperator_HueCompositeOp,
            CompositeOperator::In               => magick_rust::bindings::CompositeOperator_InCompositeOp,
            CompositeOperator::Intensity        => magick_rust::bindings::CompositeOperator_IntensityCompositeOp,
            CompositeOperator::Lighten          => magick_rust::bindings::CompositeOperator_LightenCompositeOp,
            CompositeOperator::LightenIntensity => magick_rust::bindings::CompositeOperator_LightenIntensityCompositeOp,
            CompositeOperator::LinearBurn       => magick_rust::bindings::CompositeOperator_LinearBurnCompositeOp,
            CompositeOperator::LinearDodge      => magick_rust::bindings::CompositeOperator_LinearDodgeCompositeOp,
            CompositeOperator::LinearLight      => magick_rust::bindings::CompositeOperator_LinearLightCompositeOp,
            CompositeOperator::Luminize         => magick_rust::bindings::CompositeOperator_LuminizeCompositeOp,
            CompositeOperator::Mathematics      => magick_rust::bindings::CompositeOperator_MathematicsCompositeOp,
            CompositeOperator::MinusDst         => magick_rust::bindings::CompositeOperator_MinusDstCompositeOp,
            CompositeOperator::MinusSrc         => magick_rust::bindings::CompositeOperator_MinusSrcCompositeOp,
            CompositeOperator::Modulate         => magick_rust::bindings::CompositeOperator_ModulateCompositeOp,
            CompositeOperator::ModulusAdd       => magick_rust::bindings::CompositeOperator_ModulusAddCompositeOp,
            CompositeOperator::ModulusSubtract  => magick_rust::bindings::CompositeOperator_ModulusSubtractCompositeOp,
            CompositeOperator::Multiply         => magick_rust::bindings::CompositeOperator_MultiplyCompositeOp,
            CompositeOperator::No               => magick_rust::bindings::CompositeOperator_NoCompositeOp,
            CompositeOperator::Out              => magick_rust::bindings::CompositeOperator_OutCompositeOp,
            CompositeOperator::Over             => magick_rust::bindings::CompositeOperator_OverCompositeOp,
            CompositeOperator::Overlay          => magick_rust::bindings::CompositeOperator_OverlayCompositeOp,
            CompositeOperator::PegtopLight      => magick_rust::bindings::CompositeOperator_PegtopLightCompositeOp,
            CompositeOperator::PinLight         => magick_rust::bindings::CompositeOperator_PinLightCompositeOp,
            CompositeOperator::Plus             => magick_rust::bindings::CompositeOperator_PlusCompositeOp,
            CompositeOperator::Replace          => magick_rust::bindings::CompositeOperator_ReplaceCompositeOp,
            CompositeOperator::Saturate         => magick_rust::bindings::CompositeOperator_SaturateCompositeOp,
            CompositeOperator::Screen           => magick_rust::bindings::CompositeOperator_ScreenCompositeOp,
            CompositeOperator::SoftLight        => magick_rust::bindings::CompositeOperator_SoftLightCompositeOp,
            CompositeOperator::SrcAtop          => magick_rust::bindings::CompositeOperator_SrcAtopCompositeOp,
            CompositeOperator::Src              => magick_rust::bindings::CompositeOperator_SrcCompositeOp,
            CompositeOperator::SrcIn            => magick_rust::bindings::CompositeOperator_SrcInCompositeOp,
            CompositeOperator::SrcOut           => magick_rust::bindings::CompositeOperator_SrcOutCompositeOp,
            CompositeOperator::SrcOver          => magick_rust::bindings::CompositeOperator_SrcOverCompositeOp,
            CompositeOperator::Threshold        => magick_rust::bindings::CompositeOperator_ThresholdCompositeOp,
            CompositeOperator::VividLight       => magick_rust::bindings::CompositeOperator_VividLightCompositeOp,
            CompositeOperator::Xor              => magick_rust::bindings::CompositeOperator_XorCompositeOp,
            CompositeOperator::Stereo           => magick_rust::bindings::CompositeOperator_StereoCompositeOp,
        }
    }
}

impl From<magick_rust::bindings::CompositeOperator> for CompositeOperator {
    fn from(from: magick_rust::bindings::CompositeOperator) -> Self {
        match from {
            magick_rust::bindings::CompositeOperator_UndefinedCompositeOp => CompositeOperator::Undefined,
            magick_rust::bindings::CompositeOperator_AlphaCompositeOp => CompositeOperator::Alpha,
            magick_rust::bindings::CompositeOperator_AtopCompositeOp => CompositeOperator::Atop,
            magick_rust::bindings::CompositeOperator_BlendCompositeOp => CompositeOperator::Blend,
            magick_rust::bindings::CompositeOperator_BlurCompositeOp => CompositeOperator::Blur,
            magick_rust::bindings::CompositeOperator_BumpmapCompositeOp => CompositeOperator::Bumpmap,
            magick_rust::bindings::CompositeOperator_ChangeMaskCompositeOp => CompositeOperator::ChangeMask,
            magick_rust::bindings::CompositeOperator_ClearCompositeOp => CompositeOperator::Clear,
            magick_rust::bindings::CompositeOperator_ColorBurnCompositeOp => CompositeOperator::ColorBurn,
            magick_rust::bindings::CompositeOperator_ColorDodgeCompositeOp => CompositeOperator::ColorDodge,
            magick_rust::bindings::CompositeOperator_ColorizeCompositeOp => CompositeOperator::Colorize,
            magick_rust::bindings::CompositeOperator_CopyBlackCompositeOp => CompositeOperator::CopyBlack,
            magick_rust::bindings::CompositeOperator_CopyBlueCompositeOp => CompositeOperator::CopyBlue,
            magick_rust::bindings::CompositeOperator_CopyCompositeOp => CompositeOperator::Copy,
            magick_rust::bindings::CompositeOperator_CopyCyanCompositeOp => CompositeOperator::CopyCyan,
            magick_rust::bindings::CompositeOperator_CopyGreenCompositeOp => CompositeOperator::CopyGreen,
            magick_rust::bindings::CompositeOperator_CopyMagentaCompositeOp => CompositeOperator::CopyMagenta,
            magick_rust::bindings::CompositeOperator_CopyAlphaCompositeOp => CompositeOperator::CopyAlpha,
            magick_rust::bindings::CompositeOperator_CopyRedCompositeOp => CompositeOperator::CopyRed,
            magick_rust::bindings::CompositeOperator_CopyYellowCompositeOp => CompositeOperator::CopyYellow,
            magick_rust::bindings::CompositeOperator_DarkenCompositeOp => CompositeOperator::Darken,
            magick_rust::bindings::CompositeOperator_DarkenIntensityCompositeOp => CompositeOperator::DarkenIntensity,
            magick_rust::bindings::CompositeOperator_DifferenceCompositeOp => CompositeOperator::Difference,
            magick_rust::bindings::CompositeOperator_DisplaceCompositeOp => CompositeOperator::Displace,
            magick_rust::bindings::CompositeOperator_DissolveCompositeOp => CompositeOperator::Dissolve,
            magick_rust::bindings::CompositeOperator_DistortCompositeOp => CompositeOperator::Distort,
            magick_rust::bindings::CompositeOperator_DivideDstCompositeOp => CompositeOperator::DivideDst,
            magick_rust::bindings::CompositeOperator_DivideSrcCompositeOp => CompositeOperator::DivideSrc,
            magick_rust::bindings::CompositeOperator_DstAtopCompositeOp => CompositeOperator::DstAtop,
            magick_rust::bindings::CompositeOperator_DstCompositeOp => CompositeOperator::Dst,
            magick_rust::bindings::CompositeOperator_DstInCompositeOp => CompositeOperator::DstIn,
            magick_rust::bindings::CompositeOperator_DstOutCompositeOp => CompositeOperator::DstOut,
            magick_rust::bindings::CompositeOperator_DstOverCompositeOp => CompositeOperator::DstOver,
            magick_rust::bindings::CompositeOperator_ExclusionCompositeOp => CompositeOperator::Exclusion,
            magick_rust::bindings::CompositeOperator_HardLightCompositeOp => CompositeOperator::HardLight,
            magick_rust::bindings::CompositeOperator_HardMixCompositeOp => CompositeOperator::HardMix,
            magick_rust::bindings::CompositeOperator_HueCompositeOp => CompositeOperator::Hue,
            magick_rust::bindings::CompositeOperator_InCompositeOp => CompositeOperator::In,
            magick_rust::bindings::CompositeOperator_IntensityCompositeOp => CompositeOperator::Intensity,
            magick_rust::bindings::CompositeOperator_LightenCompositeOp => CompositeOperator::Lighten,
            magick_rust::bindings::CompositeOperator_LightenIntensityCompositeOp => CompositeOperator::LightenIntensity,
            magick_rust::bindings::CompositeOperator_LinearBurnCompositeOp => CompositeOperator::LinearBurn,
            magick_rust::bindings::CompositeOperator_LinearDodgeCompositeOp => CompositeOperator::LinearDodge,
            magick_rust::bindings::CompositeOperator_LinearLightCompositeOp => CompositeOperator::LinearLight,
            magick_rust::bindings::CompositeOperator_LuminizeCompositeOp => CompositeOperator::Luminize,
            magick_rust::bindings::CompositeOperator_MathematicsCompositeOp => CompositeOperator::Mathematics,
            magick_rust::bindings::CompositeOperator_MinusDstCompositeOp => CompositeOperator::MinusDst,
            magick_rust::bindings::CompositeOperator_MinusSrcCompositeOp => CompositeOperator::MinusSrc,
            magick_rust::bindings::CompositeOperator_ModulateCompositeOp => CompositeOperator::Modulate,
            magick_rust::bindings::CompositeOperator_ModulusAddCompositeOp => CompositeOperator::ModulusAdd,
            magick_rust::bindings::CompositeOperator_ModulusSubtractCompositeOp => CompositeOperator::ModulusSubtract,
            magick_rust::bindings::CompositeOperator_MultiplyCompositeOp => CompositeOperator::Multiply,
            magick_rust::bindings::CompositeOperator_NoCompositeOp => CompositeOperator::No,
            magick_rust::bindings::CompositeOperator_OutCompositeOp => CompositeOperator::Out,
            magick_rust::bindings::CompositeOperator_OverCompositeOp => CompositeOperator::Over,
            magick_rust::bindings::CompositeOperator_OverlayCompositeOp => CompositeOperator::Overlay,
            magick_rust::bindings::CompositeOperator_PegtopLightCompositeOp => CompositeOperator::PegtopLight,
            magick_rust::bindings::CompositeOperator_PinLightCompositeOp => CompositeOperator::PinLight,
            magick_rust::bindings::CompositeOperator_PlusCompositeOp => CompositeOperator::Plus,
            magick_rust::bindings::CompositeOperator_ReplaceCompositeOp => CompositeOperator::Replace,
            magick_rust::bindings::CompositeOperator_SaturateCompositeOp => CompositeOperator::Saturate,
            magick_rust::bindings::CompositeOperator_ScreenCompositeOp => CompositeOperator::Screen,
            magick_rust::bindings::CompositeOperator_SoftLightCompositeOp => CompositeOperator::SoftLight,
            magick_rust::bindings::CompositeOperator_SrcAtopCompositeOp => CompositeOperator::SrcAtop,
            magick_rust::bindings::CompositeOperator_SrcCompositeOp => CompositeOperator::Src,
            magick_rust::bindings::CompositeOperator_SrcInCompositeOp => CompositeOperator::SrcIn,
            magick_rust::bindings::CompositeOperator_SrcOutCompositeOp => CompositeOperator::SrcOut,
            magick_rust::bindings::CompositeOperator_SrcOverCompositeOp => CompositeOperator::SrcOver,
            magick_rust::bindings::CompositeOperator_ThresholdCompositeOp => CompositeOperator::Threshold,
            magick_rust::bindings::CompositeOperator_VividLightCompositeOp => CompositeOperator::VividLight,
            magick_rust::bindings::CompositeOperator_XorCompositeOp => CompositeOperator::Xor,
            magick_rust::bindings::CompositeOperator_StereoCompositeOp => CompositeOperator::Stereo,
            _ => CompositeOperator::Undefined,
        }
    }
}
